;**********************************************************************
;   								      *
;   	Code de Joyeux						      *
;   	La PMI qui se dirige vers les balises !			      *
;                                                                     *
;	2ere version						      *
;	Codage de l'algo				              *
;	Reception definitive					      *
;	Reglages sur l'algo					      *
;	sur la carte definitive					      *
;	Reglages 1 semaine avant				      *
;	Version 5 : test avec booom sur la cooline du depart	      *
;							              *
;**********************************************************************
;                                                                     *
;    Filename:	    Joyeux05.asm                                      *
;    Date:          24/5/00                                           *
;    File Version:  5	                                              *
;                                                                     *
;    Author:        Julien                                            *
;    Compagnie:      http://fribotte.free.fr/			      *
;                                                                     * 
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required: rien                                             *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    EEPROM required: 	                                              *
;	Code des 4 balise (valeur de 1 a 16 decimal)   		      *
;	Si 0 repart a la 1ere balise				      *
;	dans les 4 premiers octet de l'EEPROM   		      *
;	Suivit ensuite du code du demarrage au timer		      *
;								      *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes: Quartz 4 Mhz                                              *
;                                                                     *
;                                                                     *
;**********************************************************************


	list      p=16F84             ; list directive to define processor
	#include <p16F84.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
; Pas de code protege, pas de watch hdog timer, delai de demarrage, horloge XT.


;  Brochage du PIC sur la carte :
;
;  Port | Broche | E/S | Nom             | Description
;       |        |     |                 |
;  RA0  |    17  |  S  | CSPortAMDroit   | Sortie Commande Moteur Droit
;  RA1  |    18  |  S  | CSPortAMGauche  | Sortie Commande Moteur Gauche
;  RA2  |     1  |  S  | CSPortATourelle | Sortie Commande Tourelle
;  RA3  |     2  |  E  |                 |
;  RA4  |     3  |  E  |  
;       |        |     |                 |
;  RB0  |     6  |  E  | CEPortBDmarre  | Entre Dmarrage
;  RB1  |     7  |  B  | CBPortBLED1     | E/S Commande Led Verte et Orange
;  RB2  |     8  |  B  | CBPortBLED2     | E/S Commande Led Rouge et Jaune
;  RB3  |     9  |  E  |                 | Entree capteur IR (balise)
;  RB4  |    10  |  E  | 		 | 
;  RB5  |    11  |  E  | CEPortBObstacle | Entre Switch Obstacle Avant
;  RB6  |    12  |  E  | CEPortBJumper1	 | Jumper de selections 1
;  RB7  |    13  |  E  | CEPortBJumper2	 | Jumper de selections 2


;**********************************************************************
;                                                                     *
;    Defines (constantes, etc)                                        *
;	Non lies a des variables				      *
;                                                                     *
;                                                                     *
;**********************************************************************

DebutRamInit	EQU	0x0C		; Debut de la RAM pour initialisation
FinRamInit	EQU	0x4F		; FIN de la RAM pour initialisation

;***** Defines lies aux phases

PauseRotation	EQU	D'105'		; Valeur a atteindre au compteur avant de finir la rotation sur place
PauseDroit	EQU	D'155'		; Valeur a atteindre au compteur avant de finir la phase 'tout droit'
PauseDroitArr	EQU	D'40'		; Valeur a atteindre au compteur avant de finir la phase 'tout droit', partie arriere
PauseChoc	EQU	D'50'		; Valeur a atteindre au compteur avant de finir la phase 'recule suite choc'
PauseChocArr	EQU	D'10'		; Valeur a atteindre au compteur avant de finir la phase 'recule suite choc', partie je recule tout droit
PauseRecherche	EQU	D'40'		; Valeur a atteindre au compteur avant d'attendre que la tourelle aille en butee

;***** Defines lies aux servos

TourelleMax	EQU	D'240'		; Valeur max du PWM de la tourelle
TourelleMin	EQU	D'50'		; Valeur min du PWM de la tourelle
TourelleMilieu	EQU	D'155'		; Valeur milieu du PWM de la tourelle (dirigee vers l'avant)

TourelleMilEM	EQU	D'142'		; Milieu - epsilon
TourelleMilEP	EQU	D'168'		; Milieu + epsilon

TourelleMilGM	EQU	D'130'		; Milieu - grand ecart
TourelleMilGP	EQU	D'180'		; Milieu + grand ecart

;***** Defines lies aux ports A
BitTourelle	EQU	0x2		; Tourelle sur Bit 2 du port A
BitMoteurDroit	EQU	0x0		; Moteur droit sur Bit 0 du port A
BitMoteurGauche	EQU	0x1		; Moteur Gauche sur Bit 1 du port A

;***** Defines lies aux ports B
CEPortBDmarre  EQU	0x0		; Entre Dmarrage
CBPortBLED1	EQU	0x1		; E/S Commande Led Verte et Orange
CBPortBLED2	EQU 	0x2		; E/S Commande Led Rouge et Jaune
CEPortBObstacle EQU	0x5		; Entre Switch Obstacle Avant
CEPortBJumper1  EQU	0x6		; Jumper de selections 1
CEPortBJumper2	EQU	0x7		; Jumper de selections 2 -> Demarrage avec ou sans timer 0V demarrage avec +5V demmarage sans


;***** Defines lies au Prescaler et au TMR0
CPrescaler1	EQU	B'10000000'	; prescaler  2
CTMR1		EQU	D'22'		; dure 0,49 ms
CPrescaler2	EQU	B'10000010'	; prescaler  8
CPrescaler4	EQU	B'10000100'	; prescaler  32
CTMR4		EQU	D'32'		; dure 7,16ms
CPrescaler5	EQU	B'10000101'	; prescaler  64
CTMR5		EQU	D'97'		; dure 10.176 ms

; on regele temporairement ces prescaler a 2 pour aller plus vite dans la simulation
;CPrescaler2	EQU	B'10000000'	; prescaler  2 au lieu de 8 !
;CPrescaler4	EQU	B'10000000'	; prescaler  2 au lieu de 32 !
;CPrescaler5	EQU	B'10000000'	; prescaler  2 au lieu de 64 !


;**********************************************************************
;                                                                     *
;    Variables                                                        *
;	Et define associes					      *
;                                                                     *
;                                                                     *
;**********************************************************************



;***** VARIABLE interruption
w_temp        	EQU     0x0C        	; variable used for context saving 
status_temp   	EQU     0x0D        	; variable used for context saving

;***** Variables globales Interruptions/main
NewInterrution 	EQU	0x0E		; Mis a 1 par l'interruption (quand elle est terminee)
Compteur	EQU	0x0F		; Compteur incremente par l'interruption
Compteur256	EQU	0x10		; Compteur incremente par l'interruption, 256 * Compteur
Obstacle	EQU	0x11		; Detection d'un obstacle Oui/non
BaliseDetect	EQU	0x12		; Detection de la balise, Oui/non
Demarrage	EQU	0x34		; Detection du demarrage, Oui/non

;***** VARIABLE PWM
PwmTourelle	EQU	0x22		; Valeur du PWM a appliquer entre 0 et 256 pour la tourelle

GestMoteur	EQU	0x21		; Gestion des moteurs
					; Rpartition des bits de GestMoteur
CActMDroit	EQU	0		; Activation moteur de droite ; 1=Activ
CSenMDroit	EQU	1		; Sens Moteur droite ; 1=vers l'avant
CActMGauche	EQU	2		; Activation moteur de gauche ; 1=Activ
CSenMGauche	EQU	3		; Sens Moteur gauche ; 1=vers l'avant
CActTourelle	EQU	4		; Activation de la tourelle ; 1=Active


;***** VARIABLE IR
CompteurIR	EQU 	0x13		; Compteur IR pour mesurer 256 emissions
ValeurIr	EQU 	0x14		; Valeur IR a fournir pendant 1 cycle
ResultatIr	EQU 	0x15		; Passe a 0 par la boucle d'emission IR si resultat pas bon.
BrouillageIR	EQU 	0x16		; Passe a 1 par la boucle d'emission IR si brouillage detecte.
Nb1DetectIr	EQU 	0x17		; Nombre de detection de "1" effectuee dans la boucle d'emission IR (1/2 periode)
Nb1DetectIrtmp	EQU 	0x18		; Nombre de detection de "1" effectuee dans la boucle d'emission IR (1/2 periode)

NbDetectConsec  EQU 	0x33		; Nombre de detection de la balise consecutive (toutes les 20ms)
NbDetectConsecN	EQU	D'1'		; Nombre de detection consecutive avant rotation

;***** Gestion de la tourelle/detection de balise
SensdeRotation  EQU	0x19		; Pour stoquer le sens dans lequel on cherche la balise.
					;	1 -> on incremente
					; 	FF -> on decremente
BaliseAChercher	EQU	0x1A		; Numero de la balise a rechercher actuellement (de 1 a 16)
CompteurMax	EQU	0x1B		;  Compteur pour l'asservissement
CompteurMaxAvance 	EQU	D'32'	; 	Valeur maximale de ce compteur pour lequel le robot continue a avancer
CompteurMaxAsserv	EQU	D'128'	; 	Valeur maximale de ce compteur pour lequel le robot continue a chercher
Avance		EQU	0x1C		;  pendant l'asservissement, avance ou non ...


;**** Compteur de depassement de phases
CmpToutDroit	EQU	0x1D	; incremente a chaque phase forcee tout droit
CmpToutDroitMax	EQU	D'10' ; Valeur maximale a ne pas depasser pour CmpVaToutDroit

CmpDeChoc	EQU	0x1E	; incremente a chaque choc detecte
CmpDeChocMax	EQU	D'5' ; Valeur maximale a ne pas depasser pour CmpDeChoc

CmpPerduBal	EQU	0x1F	; incremente a chaque perte de balise
CmpPerduBalMax	EQU	D'10' ; Valeur maximale a ne pas depasser pour CmpPerduBal

;**** Les differentes phases dans l'interruption
Phase		EQU	0x23		; Les diffrents cycles.
CPhaseDesactive	EQU	0		; PMI dsactive
CPhase1		EQU	0		; Codage par bit
CPhase2		EQU	1
CPhase3		EQU	2
CPhase4		EQU	3
CPhase5		EQU	4
CPhaseMax	EQU	5

;**** Variable detection de balise (code de JC)
DureeMax	EQU	0x2E		; Dure max d'un signal 1
DureeTotal	EQU	0x2F		; Dure Total du niveau 1
DureeTmp	EQU	0x30		; Dure provisoire
Balise		EQU	0x31		; Numero Balise
Boucle		EQU	0x32		; Nombre de lecture

CtolreBalise 	EQU	D'1'		; la tolrance de 1  10

;**** Le depart au timer
PointerEEProm	EQU	0x24		; Poiteur dans l'EEPRom pour voir ou on en est
					;  sur la partie timer
					;  et aussi sur les balises
ValeurTimer	EQU	0x25		; Valeur que le pointeur doit atteindre
CmpDemarrage	EQU	0x35		; Detection du demarrage, Oui/non

;**********************************************************************
;                                                                     *
;    Contenu de l'EEPROM                                              *
;                                                                     *
;                                                                     *
;**********************************************************************

; definition des valeurs mis dans l'EEPROM
	 	org 	H'2100'

		; les balises
		DE 	D'16', D'14', D'0', D'0'

; H'40', D'X' Pause de d'X' * 20 ms
; H'0F', D'X' Avance de d'X' * 20 ms
; H'05', D'X' Recule de d'X' * 20 ms
; H'07', D'X' tourne a droite de d'X' * 20 ms
; H'0D', D'X' tourne a gauche de d'X' * 20 ms
; H'04', D'X' Recule juste de gauche d'X' * 20 ms
; H'01', D'X' Recule juste de Droite d'X' * 20 ms

		; pause au depart
		DE 	H'40', D'250', H'40', D'0'

		; Demarrage , pause sur la colline, fin de la descente
		DE	H'0F', D'100', H'40', D'250', H'40', D'100', H'0F', D'100'

		; droite, avance, droite, avance jusqu'au milieu et gauche
		DE	H'07', D'30', H'0F', D'82', H'07', D'25', H'0F', D'240', H'0D', D'20'

		; pause au milieu
		;DE	H'40', D'200', H'40', D'0' 

		; A la place de la pause, recule, puis pousse un peu des 2 cotes, puis pause
		DE	H'05', D'150', H'01', D'50', H'04', D'50', H'40', D'50', H'40', D'0'

		; avance dans le ravin (part de plus loin)
		DE	H'0F', D'250', H'0F', D'150'

		; avance dans le ravin (ancienne version)
		;DE	H'0F', D'250', H'0F', D'100'

		; vers le ballon desactive
		; 0x0D, D'10', 0x0F, D'100'


;***************************** DEBUT **********************************
		ORG     0x000           ; processor reset vector
  		GOTO    main            ; go to beginning of program



;**********************************************************************
;                                                                     *
;    Interruption Timer                                               *
;                                                                     *
;                                                                     *
;**********************************************************************

		ORG     0x004           ; interrupt vector location

;***** Sauvegarde contexte
		MOVWF   w_temp          ; save off current W register contents
		MOVF	STATUS,0        ; move status register into W register
		MOVWF	status_temp     ; save off contents of STATUS register

;La premire chose a faire est l'init du TMR.
; On regle le prescaler
		CLRWDT			; Clear WDT et prescaler
		BSF	STATUS,RP0	; Bank 1
		MOVLW	CPrescaler2	; Si phase=1 alors prescaler1
		BTFSC	Phase,CPhase1	; Si phase=4 alors prescaler4
		MOVLW	CPrescaler1	; Si phase=5 alors prescaler5
		BTFSC	Phase,CPhase4	; Si Non prescaler2
		MOVLW	CPrescaler4
		BTFSC	Phase,CPhase5
		MOVLW	CPrescaler5
		MOVWF	OPTION_REG
		BCF	STATUS,RP0	; Bank 0

		MOVF	PwmTourelle,W	; Si phase=1 alors CTMR1
		BTFSC	Phase,CPhase3	; Si phase=4 alors CTMR4
		SUBLW	0xFF		; Si phase=5 alors CTMR5
		BTFSC	Phase,CPhase1	; si Non TMR0=PwmTourelle
		MOVLW	CTMR1		; mais si Phase3 invers TMR0
		BTFSC	Phase,CPhase4
		MOVLW	CTMR4
		BTFSC	Phase,CPhase5
		MOVLW	CTMR5
		MOVWF	TMR0

;Aiguillage vers les diffrentes phases

		BTFSC	Phase,CPhase2	;Attention Phase 2 et 3,
		GOTO	LPhase2		; on une dure minimale critique.
		BTFSC	Phase,CPhase3
		GOTO	LPhase3
		BTFSC	Phase,CPhase1
		GOTO	LPhase1
		BTFSC	Phase,CPhase4
		GOTO	LPhase4
		BTFSC	Phase,CPhase5
		GOTO	LPhase5
		GOTO	LFinPhase	; Si non FIN, on ne sait jamais.

;  *********
LPhase1 
; Dure 0,5 ms
; Dbut des impulsions des 3 servos s'ils sont actifs
		BTFSC	GestMoteur,CActMDroit
		BSF	PORTA,BitMoteurDroit
		BTFSC	GestMoteur,CActMGauche
		BSF	PORTA,BitMoteurGauche
		BTFSC	GestMoteur,CActTourelle
		BSF	PORTA,BitTourelle 
		GOTO	LFinPhase

;  *********
LPhase2
; Dure de 0  2ms
; Fin impulsion moteur Droit si le robot Avance
		BTFSC	GestMoteur,CSenMDroit
		BCF	PORTA,BitMoteurDroit
; Fin impulsion moteur Gauche si robot recule
		BTFSS	GestMoteur,CSenMGauche
		BCF	PORTA,BitMoteurGauche
; Ne rien ajouter, influence le CPwmMax	
		GOTO	LFinPhase

;  *********
LPhase3
; Dure de 2ms  0 ( complment de la phase 2 )
; Fin impulsion tourelle dure de 0,5  2,5ms
		BCF	PORTA,BitTourelle
; Ne rien ajouter, influence le CPwmMin

		GOTO	LFinPhase

;  *********
LPhase4
; Dure 7,5ms
; Fin impulsion Moteur Droite et Gauche dure 2,5ms
		BCF	PORTA,BitMoteurDroit
		BCF	PORTA,BitMoteurGauche
		GOTO	LFinPhase
; la suite n'est excut que si la pmi est activ.


;**********************************************************************
; Gestion des capteurs et des compteurs
;**********************************************************************
LPhase5
; Test de la valeur de l'obstacle
; Test de la detection de la balise
		
		INCF	Compteur,F	; Incremente le compteur
		; il faudrait ici gerer aussi le Compteur255

		CLRF	NewInterrution 	; Passe NewInterrution a 1
		INCF	NewInterrution, F	;	"

		CALL 	RecepBalise	; On teste la reception de la balise
		
		; On recopie le resultat des tests sur le port B.
		; si on a Balise = BaliseAChercher on met BaliseDetect a 1
		CLRF 	BaliseDetect
		MOVF	Balise, W
		SUBWF	BaliseAChercher, W
		BTFSC	STATUS, Z
		BSF	BaliseDetect, 0	; On met Balise a 1				

		BCF	PORTB, CBPortBLED1	; On met a 0 (tres peu de temps) les BIT resustats	
		BCF	PORTB, CBPortBLED2	;	/

		BTFSC	BaliseDetect,0	; BaliseDetect a 1 ?
		BSF	PORTB, CBPortBLED1	; Cas ResultatIr = 1 , on passe le bit 2 du PORT A a 1 (Detection)
		;BTFSC	BrouillageIR,0	; Signal brouille ?
		;BSF	PORTB, CBPortBLED2	; Cas BrouillageIR = 1 , on passe le bit 3 du PORT A a 1 (Brouillage)

		
		; Test de la valeur de l'obstacle
		CLRF	Obstacle	; on met obstacle a 0
		BTFSC	PORTB, CEPortBObstacle	; si on detecte l'obstacle
		INCF	Obstacle	; On met obstacle a 1

		; Test de la valeur du demmarage

		CLRF	Demarrage	; on met demarrage a 0
		BTFSC	PORTB, CEPortBDmarre	; si on detecte pas le demarrage
		GOTO	LFinPhase	; On continue
		
		INCF 	Demarrage	; sinon on met demarrage a 1
		BSF	PORTB, CBPortBLED2	; On met a 1 la led 2
					

;**********************************************************************

LFinPhase
;Phase suivante pour la prochaine interruption.
		BCF	STATUS,C	; Clear de la retenue
		RLF	Phase,F		; Rotation d'un bit
		BTFSC	Phase,CPhaseMax	; si phase=PhaseMax
		BSF	Phase,CPhase1	; alors Phase=1
		BCF	Phase,CPhaseMax ; Pour tre rigoureux, Pas de bits qui tranent.

;***** Redmarrage interruption et Restitution contexte

		MOVF    status_temp,W	; restore STATUS
		MOVWF	STATUS		; /
		SWAPF   w_temp,F  	; restore W
		SWAPF   w_temp,W        ; / 

		BCF 	INTCON,	T0IF	; On efface l'interruption TimeR

		RETFIE                  ; return aprs l'interruption






;**********************************************************************
;                                                                     *
;    Programme Main                                                   *
;                                                                     *
;                                                                     *
;**********************************************************************


main

;***** initialisations

		CALL 	InitRAM 	; Met toute la RAM a 0
		MOVLW	0x01
		MOVWF	Phase		; Init de la phase a 1

		CALL	InitIO		; On intialise les ports d'E/S (A et B)
		CALL 	InitRtcc	; On intialise l'interruption TimeR (activation des servos)

; Ici on aura une premiere phase au timer (ou au capteur de ligne) pour aller de l'autre cote du terrain
; puis on continue la, a l'etape 1

;**********************************************************************
;    Phases de mouvements au timer                                     *
;**********************************************************************

;***** Etape 0 , le demarrage au timer. Boucle de lecture des ordres

Etape0		CALL	SensTourelleP ; Fixe le sens de rotation de la tourelle + Fixer PointerEEProm ?
		MOVLW	0x03
		MOVWF	PointerEEProm ; Init de PointerEEProm a 3 (+ 1 = 4 un a a ligne suivante)

		; dans cas ou le jumper 2 est a +5V (mode debug), on saute toute cette etape 
		BTFSC	PORTB, CEPortBJumper2
		GOTO	FinEtape0

		; d'abord l'attente de 10 secondes avant les premiers tests de l'allumage
		CALL 	STourelleDroite ; On fixe les valeurs des servos

		CALL 	InitCompteur	; On initialise les compteurs
Boucle1DepartEtape0			
		MOVLW	D'250'	; On teste si Compteur<250 (5 s)
		SUBWF	Compteur, W	
		BTFSS	STATUS, C	
		GOTO	Boucle1DepartEtape0	;	Si oui, on revient a Boucle1DepartEtape0

		CALL 	InitCompteur	; On initialise les compteurs
Boucle2DepartEtape0	
		MOVLW	D'250'	; On teste si Compteur<250 (5 s)
		SUBWF	Compteur, W	
		BTFSS	STATUS, C	
		GOTO	Boucle2DepartEtape0	;	Si oui, on revient a Boucle2DepartEtape0

		; ensuite on attend que le demarrage soit a 1 pendant 1s consecutive
		CLRF	CmpDemarrage;

Boucle3DepartEtape0	
		CALL	AttenteNewInter	; on attends une nouvelle interruption
		INCF	CmpDemarrage, F	; on increment le compteur de demarage
		BTFSS	Demarrage, 0	; si il n'y a pas detection, on remet le compteur de demarage a 0
		CLRF	CmpDemarrage;

		MOVLW	D'50'	; On teste si CmpDemarrage<50 (1 s)
		SUBWF	CmpDemarrage, W	
		BTFSS	STATUS, C	
		GOTO	Boucle3DepartEtape0	;	Si oui, on revient a Boucle3DepartEtape0

		
;		; on attendenfin encore 5s avant de demarrer la phase au timer
;		CALL 	InitCompteur	; On initialise les compteurs
;Boucle4DepartEtape0	
;		MOVLW	D'250'	; On teste si Compteur<250 (5 s)
;		SUBWF	Compteur, W	
;		BTFSS	STATUS, C	
;		GOTO	Boucle4DepartEtape0	;	Si oui, on revient a Boucle4DepartEtape0

		



BoucleEtape0 	; On lit la valeur de l'EEProm en PointerEEProm
	
		INCF	PointerEEProm	; On met PointerEEProm a 4, ou on l'incremente
					;	On garde les valeur 0-3 pour les balises

		CALL 	LireEEProm	; On lit la valeur dans l'EEPROM (passe dans W)
		MOVWF	GestMoteur	; On met la valeur retournee dans GestMoteur

		; si GestMoteur = 0 Fini
		BTFSC	STATUS,Z	; GestMoteur = 0 ?
		GOTO 	FinEtape0	
		; si W = 255, cad si le bit 7 est a 1 Fini aussi 
		BTFSC	GestMoteur, 7
		GOTO	FinEtape0

		; On lit ensuite la valeur dans le compteur a appliquer
		INCF	PointerEEProm
		CALL 	LireEEProm	; On lit la valeur dans l'EEPROM (passe dans W)
		MOVWF	ValeurTimer	; On met la valeur retournee dans ValeurTimer
		
		; si  ValeurTimer = 0 on passe au suivant
		BTFSC	STATUS,Z	;  = 0 ?
		GOTO 	BoucleEtape0	
		
		; Sinon on boucle en attendant que 
		
		CALL 	InitCompteur	; On initialise les compteurs

Boucle2Etape0	MOVF	ValeurTimer, W	; On teste si Compteur>ValeurTimer
		SUBWF	Compteur, W	
		BTFSC	STATUS, C	
		GOTO	BoucleEtape0	;	Si oui, on revient a BoucleEtape0
		
		BTFSS	Obstacle,0	; Obstacle non detecte ?
		GOTO	Boucle2Etape0	;	On boucle ici ...

		; Fin de l'etate0, on intialise la detection de la balise

		; On appelle le changement de balise avec PointerEEProm > 3 (donc il va revenir a 0)
FinEtape0	CALL 	ChangeBalise

		BTFSC	Obstacle,0	; Obstacle non detecte ?
		GOTO	Etape3		;	On va a l'etape 3

		; Sinon on continue sur l'etape 1
		


;**********************************************************************
;    Phases de mouvements forcees                                     *
;**********************************************************************

;***** Etape 1 Rotation sur soi-meme

Etape1		CALL 	InitCompteur	; On initialise les compteurs
		CALL 	STourelleDroite ; On fixe les valeurs des servos
		CALL	SMoteurGaucheA
		CALL	SMoteurDroitR

BoucleEtape1	CALL	AttenteNewInter ; On attend une nouvelle interruption

		BTFSC	BaliseDetect,0	; balise detectee ?
		INCF	NbDetectConsec	; incrementation de NbDetectConsec

		BTFSS	BaliseDetect,0	; balise non detectee ?
		CLRF	NbDetectConsec	; Mise a 0 de NbDetectConsec

		CLRF	BaliseDetect	; Dans tous les cas on remet BaliseDetect a 0

		MOVLW	NbDetectConsecN	; si NbDetectConsec = NbDetectConsecN,
		SUBWF	NbDetectConsec, W
		BTFSC	STATUS, Z
		GOTO	Etape4		; 	On va a l'etape 4

		BTFSC	Obstacle,0	; Obstacle detecte ?
		GOTO	Etape3		;	On va a l'etape 3

		MOVLW	PauseRotation	; On teste si Compteur>PauseRotation
		SUBWF	Compteur, W	
		BTFSC	STATUS, C	
		GOTO	Etape2		;	Si oui, on va a l'etape 2

		GOTO	BoucleEtape1	; Sinon boucle
		


;***** Etape 2 avance tout droit
		
Etape2		CALL 	InitCompteur	; On initialise les compteurs
		CALL 	STourelleDroite ; On fixe les valeurs des servos
		CALL	SMoteurGaucheA
		CALL	SMoteurDroitA
		INCF	CmpToutDroit,F	; On incremente le compteur "va tout droit"
		MOVLW	CmpToutDroitMax	; 	Valeur superieurs a CmpToutDroitMax ?
		SUBWF	CmpToutDroit, W
		BTFSC	STATUS, C	
		CALL	ChangeBalise	;	si oui, On change de balise ...
		
BoucleEtape2	CALL	AttenteNewInter ; On attend une nouvelle interruption

		MOVF	SensdeRotation,W; On ajoute SensdeRotation a PwmTourelle
		ADDWF	PwmTourelle,F	
		ADDWF	PwmTourelle,F	; deux fois ...

		BTFSC	BaliseDetect,0	; balise detectee ?
		INCF	NbDetectConsec	; incrementation de NbDetectConsec

		BTFSS	BaliseDetect,0	; balise non detectee ?
		CLRF	NbDetectConsec	; Mise a 0 de NbDetectConsec

		CLRF	BaliseDetect	; Dans tous les cas on remet BaliseDetect a 0

		MOVLW	NbDetectConsecN	; si NbDetectConsec = NbDetectConsecN,
		SUBWF	NbDetectConsec, W
		BTFSC	STATUS, Z
		GOTO	Etape4		; 	On va a l'etape 4

		MOVLW	TourelleMax	; On teste si PwmTourelle >  TourelleMax
		SUBWF	PwmTourelle, W	
		BTFSC	STATUS, C	
		CALL	SensTourelleM	;  Si oui, Sens decroissant		

		MOVF	PwmTourelle,W	; On teste si PwmTourelle < TourelleMin
		SUBLW	TourelleMin
		BTFSC	STATUS,C
		CALL	SensTourelleP	;  Si oui, Sens croissant		

		BTFSC	Obstacle,0	; Obstacle detecte ?
		GOTO	Etape3		;	On va a l'etape 3

		MOVLW	PauseDroit	; On teste si Compteur>PauseDroit
		SUBWF	Compteur, W	
		BTFSC	STATUS, C	
		GOTO	BoucleEtape2fin5	;	Si oui, on termine
		
		GOTO	BoucleEtape2	; Sinon boucle

BoucleEtape2fin5
;		CALL	STourelleMax	; On fixe PwmTourelle a la valeur max (tourelle d'un cote)
		CALL	SensTourelleM	;  Sens decroissant		

;		on recule un poil ...

		CALL 	InitCompteur	; On initialise les compteurs
		CALL	SMoteurGaucheR
		CALL	SMoteurDroitR

BoucleEtape2Arr MOVLW	PauseDroitArr	; On teste si Compteur>PauseDroitArr
		SUBWF	Compteur, W	
		BTFSS	STATUS, C	
		GOTO	BoucleEtape2Arr	;	Si oui, on boucle

		GOTO	Etape1		; on va a l'etape 1 (tour sur soi-meme)

;***** Etape 3 recule suite a obstacle

Etape3		CALL 	InitCompteur	; On initialise les compteurs
		CALL 	STourelleDroite ; On fixe les valeurs des servos
		CALL	SMoteurGaucheR
		CALL	SMoteurDroitR
		INCF	CmpDeChoc,F	; On incremente le compteur 'choc'
		MOVLW	CmpDeChocMax	; 	Valeur superieurs a CmpChocMax ?
		SUBWF	CmpDeChoc, W
		BTFSC	STATUS, C	
		CALL	ChangeBalise	;	si oui, On change de balise ...

BoucleEtape3_arr
		MOVLW	PauseChocArr	; On teste si Compteur>PauseChocArr (phase courte ou la PMI recule tout droit
		SUBWF	Compteur, W	; 	pour eventuellement se degager d'un probleme
		BTFSS	STATUS, C	
		GOTO	BoucleEtape3_arr	;	Si non , on boucle
	
		CALL	SMoteurGaucheS	; On arrete le moteur gauche pour tourner
		CALL 	InitCompteur	; On initialise les compteurs

BoucleEtape3	MOVLW	PauseChoc	; On teste si Compteur>PauseChoc
		SUBWF	Compteur, W	
		BTFSS	STATUS, C	
		GOTO	BoucleEtape3	;	Si non , on boucle
		
		CALL 	STourelleMax	; 	Si oui, tourelle fixe au maximum
		CALL	SensTourelleM	;	Sens tourelle moins
		GOTO	Etape2		; 	On va a l'etape 2

;**********************************************************************
;    L'asservissement			                              *
;**********************************************************************

;*****	Asservissement sur la balise

Etape4		CALL 	InitCompteur	; On initialise les compteurs
		MOVLW	0x4
		MOVWF	CompteurMax	; CompteurMax initialise a 4
		MOVLW	0x1
		MOVWF	Avance		; Avance initialise a 1
		CALL	SensTourelleP

Etape4Boucle	CALL	AttenteNewInter ; Attente d'une nouvelle interruption

		MOVF	SensdeRotation,W; On ajoute SensdeRotation a PwmTourelle
		ADDWF	PwmTourelle,F	;
		ADDWF	PwmTourelle,F	; Deux fois ...

		BTFSS	BaliseDetect,0	; balise non detectee ?
		GOTO	Etape4_1	; 	On saute
		
		CALL	InitCompteur	; 	Sinon on (re)initilise les compteurs,
		MOVLW	0x4
		MOVWF	CompteurMax	; 	CompteurMax (re)initialise a 4
		MOVLW	0x1
		MOVWF	Avance		; 	Avance (re)initialise a 1
	
Etape4_1	; teste si compteur>CompteurMax ou si en butee
		
		MOVF	CompteurMax, W	; On teste si Compteur>CompteurMax
		SUBWF	Compteur, W	
		BTFSC	STATUS, C	
		GOTO	Etape4_2	;	Si oui, on va a 4_2

		MOVLW	TourelleMax	; On teste si PwmTourelle >  TourelleMax
		SUBWF	PwmTourelle, W	
		BTFSC	STATUS, C	
		GOTO	Etape4_2	;	Si oui, on va a 4_2

		MOVF	PwmTourelle,W	; On teste si PwmTourelle < TourelleMin
		SUBLW	TourelleMin
		BTFSC	STATUS,C
		GOTO	Etape4_2	;	Si oui, on va a 4_2

		; Si rien de tout ca, on va en 4_4
		GOTO	Etape4_4

Etape4_2	; On change se sens
		MOVF	SensdeRotation,W; SensDeRotation = 1 ou FF
		SUBLW	0x1		; W = SensDeRotation - 1 (W = 0 ou FE)
		BTFSC	STATUS,Z	; W = 0 ?
		GOTO	Etape4_2_a
		CALL	SensTourelleP	
		GOTO	Etape4_2_b	; SenTourelle = 1
			
Etape4_2_a	CALL	SensTourelleM   ; SenTourelle = -1
		
		
Etape4_2_b	CALL	InitCompteur	; On (re)initilise les compteurs,

		BCF	STATUS, C
		RLF	CompteurMax, F	; CompteurMax = CompteurMax *2
		
		MOVLW	CompteurMaxAvance	; On teste si CompteurMax >  CompteurMaxAvance (on continue a avancer)
		SUBWF	CompteurMax, W	
		BTFSC	STATUS, C	
		CLRF 	Avance		;	Si oui, on met avance a 0
	
		MOVLW	CompteurMaxAsserv	; On teste si CompteurMax <  CompteurMaxAsserv (on continue a asservir)
		SUBWF	CompteurMax, W	
		BTFSS	STATUS, C	
		GOTO	Etape4_3	;	Si oui, on va en 4_3

		MOVLW	TourelleMilieu	; Si non, on est sorti des limites de la recherche
		SUBWF	PwmTourelle, W	;  on teste si PwmTourelle >  TourelleMilieu
		BTFSC	STATUS, C
		GOTO	Etape4_2_1	; Si oui on va en 4_2_1
		GOTO	Etape4_2_2	; Si non, on va en 4_2_2

Etape4_2_1	CALL	STourelleMax	; On fixe PwmTourelle a la valeur max
		CALL	SensTourelleM	;  Sens decroissant
		GOTO	Etape5		;	On va a l'etape 5

Etape4_2_2	CALL	STourelleMin	; On fixe PwmTourelle a la valeur min
		CALL	SensTourelleP	;  Sens croissant
		GOTO	Etape5		;	On va a l'etape 5						

Etape4_3	;	As-t-on la tourelle en butee ?
		
		MOVLW	TourelleMax	; On teste si PwmTourelle >  TourelleMax
		SUBWF	PwmTourelle, W	
		BTFSC	STATUS, C	
		GOTO	Etape4_3_1	;	Si oui, on va a 4_3_1

		MOVF	PwmTourelle,W	; On teste si PwmTourelle < TourelleMin
		SUBLW	TourelleMin
		BTFSC	STATUS,C
		GOTO	Etape4_3_2	;	Si oui, on va a 4_3_2
			
		GOTO	Etape4_4	; Si pas en butee on continue en 4_4

Etape4_3_1	CALL	STourelleMax	; On fixe PwmTourelle a la valeur max
		DECF	PwmTourelle, F	; PwmTourelle -1
		GOTO	Etape4_4

Etape4_3_2	CALL	STourelleMin	; On fixe PwmTourelle a la valeur min
		INCF	PwmTourelle, F	; PwmTourelle -1
		GOTO	Etape4_4


Etape4_4	; On teste Avance
		BTFSC	Avance,0	; Avance = 1 ?
		GOTO	Etape4_5	; 	Oui, va en Etape4_5
	
		CALL	SMoteurGaucheA	; 	Sinon on avance tout droit
		CALL	SMoteurDroitA	; 	
		GOTO	Etape4_6	; Et on va a l'etape 4_6
		
Etape4_5	; On a avance = 1, on se dirige suivant la detection de la tourelle

		MOVLW	TourelleMilEP	; Si PwmTourelle > Milieu + epsilon
		SUBWF	PwmTourelle, W
		BTFSC	STATUS,C
		GOTO	Etape4_5_1	;	On va en 4_5_1

		CALL	SMoteurDroitA	; 	Sinon PwmTourelle < Milieu + epsilon, donc moteur droit avance, 
;		INCF	PwmTourelle, F	;	PwmTourelle++
		INCF	PwmTourelle, F	;	PwmTourelle++
		INCF	PwmTourelle, F	;	PwmTourelle++
		GOTO	Etape4_5_3	;	On va en 4_5_3

Etape4_5_1	; On a ici PwmTourelle > Milieu + epsilon
		MOVLW	TourelleMilGP	; Si PwmTourelle > Milieu + grandEcart
		SUBWF	PwmTourelle, W
		BTFSC	STATUS,C
		GOTO	Etape4_5_2	;	On va en 4_5_2

		CALL	SMoteurDroitS	;	Sinon PwmTourelle < Milieu + grandEcart, on arrete le moteur droit
		GOTO	Etape4_5_3	; 	On va en 4_5_3

Etape4_5_2	; Ici on a PwmTourelle > Milieu + grandEcart
		CALL	SMoteurDroitR	;	On recule sur le moteur droit
;		DECF	PwmTourelle, F	;	PwmTourelle--
		DECF	PwmTourelle, F	;	PwmTourelle--
		DECF	PwmTourelle, F	;	PwmTourelle--
					; 	On va en 4_5_3 		


Etape4_5_3	MOVLW	TourelleMilEM	; Si PwmTourelle > Milieu - epsilon
		SUBWF	PwmTourelle, W
		BTFSC	STATUS,C
		GOTO	Etape4_5_4	;	On va en 4_5_4

		; on a PwmTourelle < Milieu - epsilon
		MOVLW	TourelleMilGM	; Si PwmTourelle > Milieu - grandEcart
		SUBWF	PwmTourelle, W
		BTFSC	STATUS,C
		GOTO	Etape4_5_5	;	On va en 4_5_5
		
		; in a PwmTourelle < Milieu - grandEcart
		CALL	SMoteurGaucheR	;	On recule sur le moteur gauche
;		INCF	PwmTourelle, F	;	PwmTourelle--
		INCF	PwmTourelle, F	;	PwmTourelle--
		INCF	PwmTourelle, F	;	PwmTourelle--
		GOTO	Etape4_6	;	On va en 4_6 (fin de la gestion des moteurs)

Etape4_5_5	; in a PwmTourelle > Milieu - grandEcart
		CALL	SMoteurGaucheS	;	On arrete le moteur gauche
		GOTO	Etape4_6	;	On va en 4_6 (fin de la gestion des moteurs)

Etape4_5_4	; Ici on a PwmTourelle > Milieu - epsilon
		CALL	SMoteurGaucheA	;	On avance sur le moteur gauche
;		DECF	PwmTourelle, F	;	PwmTourelle--
		DECF	PwmTourelle, F	;	PwmTourelle--
		DECF	PwmTourelle, F	;	PwmTourelle--
					; 	On va en 4_6 (fin de la gestion des moteurs)


Etape4_6	; Test de l'obstacle puis de la balise
		BTFSS	Obstacle,0 	; Obstacle detecte ?
		GOTO	Etape4Boucle	;	Non, on boucle !
		
		BTFSS	Obstacle,1 	; balise detecte ?
		CALL	ChangeBalise	; oui, on change de balise !
		GOTO	Etape3		; Dans tous les cas on va en 3 ...

;**********************************************************************
;    La recherche immobile		                              *
;**********************************************************************

;*****	Tour complet de la tourelle, PMI immobile

Etape5		CALL 	InitCompteur	; On initialise les compteurs
		INCF	CmpPerduBal,F	; On incremente le compteur "va tout droit"
		MOVLW	CmpPerduBalMax	; 	Valeur superieurs a CmpToutDroitMax ?
		SUBWF	CmpPerduBal, W
		BTFSC	STATUS, C	
		CALL	ChangeBalise	;	si oui, On change de balise ...

		CALL 	SMoteurGaucheS  ; on arrete les 2 moteurs
		CALL	SMoteurDroitS	
		; Boucle d'attente pour laisser le temps a la tourelle d'arriver en place

Etape5Boucle1	
		MOVLW	PauseRecherche	; On teste si Compteur < PauseRecherche
		SUBWF	Compteur, W	
		BTFSS	STATUS, C	
		GOTO	Etape5Boucle1	; Si oui on boucle

Etape5Boucle2	CALL	AttenteNewInter ; On attend une nouvelle interruption
		
		MOVF	SensdeRotation,W; On ajoute SensdeRotation a PwmTourelle
		ADDWF	PwmTourelle,F;
		
		BTFSC	BaliseDetect,0	; balise detectee ?
		INCF	NbDetectConsec	; incrementation de NbDetectConsec

		BTFSS	BaliseDetect,0	; balise non detectee ?
		CLRF	NbDetectConsec	; Mise a 0 de NbDetectConsec

		CLRF	BaliseDetect	; Dans tous les cas on met BaliseDetect a 0

		MOVLW	NbDetectConsecN	; si NbDetectConsec = NbDetectConsecN,
		SUBWF	NbDetectConsec, W
		BTFSC	STATUS, Z
		GOTO	Etape4		; 	On va a l'etape 4
		BTFSC	Obstacle,0	; Obstacle detecte ?
		GOTO	Etape3		;	On va a l'etape 3
				
		MOVLW	TourelleMax	; On teste si PwmTourelle >  TourelleMax
		SUBWF	PwmTourelle, W	
		BTFSC	STATUS, C	
		GOTO	Etape1		;	Si oui, on va a l'etape 1

		MOVF	PwmTourelle,W	; On teste si PwmTourelle < TourelleMin
		SUBLW	TourelleMin
		BTFSC	STATUS,C
		GOTO	Etape1		;	Si oui, on va a l'etape 1

		; Si rien de tout ca, on boucle
		GOTO	Etape5Boucle2
		

;	Fin de la gestion des etapes



;**********************************************************************
;                                                                     *
;    Initialisation de l'ensemble de la RAM                   	      *
;                                                                     *
;                                                                     *
;**********************************************************************


InitRAM				
		MOVLW	DebutRamInit	; De DebutRamInit
	        MOVWF	FSR       	; Pointeur dans la RAM
Boucle0Ram    	CLRF 	INDF       	; Efface la zone pointee
        	INCF 	FSR,F        	; incremente le pointer
		MOVF	FSR,W		; on compare FSR a FinRamInit
		SUBLW	FinRamInit
		BTFSC	STATUS,C
		GOTO	Boucle0Ram	; Jusqu'a ce que FinRamInit
		
	RETURN


;**********************************************************************
;                                                                     *
;    Initialisation du compteur		                   	      *
;                                                                     *
;                                                                     *
;**********************************************************************


InitCompteur	CLRF	Compteur	; On initialise les compteurs 
		CLRF	Compteur256	;	(Attention, si on fait pas dans ce sens (compteur puis compteur256
		CLRF	NbDetectConsec	; 	
	RETURN				;	on risque des problemes lors des interruptions !)
		

;**********************************************************************
;                                                                     *
;    Reglages des PWM des moteurs/tourelles                   	      *
;                                                                     *
;                                                                     *
;**********************************************************************


STourelleDroite
		MOVLW	TourelleMilieu	; 
		MOVWF	PwmTourelle	; On fixe le PWM de la tourelle pour qu'elle soit devant (a peu pres) (190)
		BSF	GestMoteur,CActTourelle ; Tourelle active
	RETURN

STourelleMax	MOVLW	TourelleMax	; 
		MOVWF	PwmTourelle	; On fixe le PWM de la tourelle pour qu'elle soit au max
	RETURN	

STourelleMin	MOVLW	TourelleMin	; 
		MOVWF	PwmTourelle	; On fixe le PWM de la tourelle pour qu'elle soit au min
	RETURN	

STourelleStop	BCF	GestMoteur,CActTourelle ; Tourelle desactivee
	RETURN	


SensTourelleM	MOVLW	0xFF
		MOVWF	SensdeRotation	; Sens tourelle a -1
	RETURN

SensTourelleP	CLRF	SensdeRotation	; Sens tourelle a 1
		BSF	SensdeRotation,0;	/
	RETURN

SMoteurGaucheA
		BSF	GestMoteur,CActMGauche	; Moteur gauche avance
		BSF	GestMoteur,CSenMGauche	;	/
	RETURN

SMoteurGaucheR
		BSF	GestMoteur,CActMGauche	; Moteur gauche recule
		BCF	GestMoteur,CSenMGauche	;	/
	RETURN

SMoteurGaucheS
		BCF	GestMoteur,CActMGauche	; Moteur gauche stop
	RETURN

SMoteurDroitA
		BSF	GestMoteur,CActMDroit	; Moteur droit avance
		BSF	GestMoteur,CSenMDroit	;	/
	RETURN

SMoteurDroitR
		BSF	GestMoteur,CActMDroit	; Moteur droit recule
		BCF	GestMoteur,CSenMDroit	;	/
	RETURN

SMoteurDroitS
		BCF	GestMoteur,CActMDroit	; Moteur droit stop
	RETURN


;**********************************************************************
;                                                                     *
;    Changement de balise		                   	      *
;                                                                     *
;                                                                     *
;**********************************************************************

ChangeBalise	; on efface les compteur de depassement
		CLRF 	CmpToutDroit
		CLRF	CmpDeChoc
		CLRF	CmpPerduBal

		; On increment le pointeur dans l'EEPROM
		INCF	PointerEEProm
		; Si il est superieur a 4 on le remet a 0
		MOVLW	0x04
		SUBWF	PointerEEProm, W
		BTFSC	STATUS, C
		CLRF 	PointerEEProm

		CALL 	LireEEProm	; On lit la valeur dans l'EEPROM (passe dans W)
		MOVWF	BaliseAChercher	; On met la valeur retournee dans attenteBalise

		; si BaliseAChercher = FF on remet BaliseAChercher a 0
		BTFSC	BaliseAChercher, 7
		CLRF	BaliseAChercher

		; si null on remet PointerEEProm a 0
		MOVF	BaliseAChercher, W
		BTFSS	STATUS, Z
		GOTO	ChangeBaliseNN

		
		CLRF 	PointerEEProm
		CALL 	LireEEProm	; On lit la valeur dans l'EEPROM (passe dans W)
		MOVWF	BaliseAChercher	; On met la valeur retournee dans attenteBalise
						
ChangeBaliseNN	; on teste la valeur retourne pour la balise
		MOVF	BaliseAChercher, W
		BTFSC	STATUS, Z
		INCF	BaliseAChercher	; si BaliseAChercher = 0, BaliseAChercher =1

		MOVLW	D'16'
		BTFSC	BaliseAChercher, 7
		MOVWF	BaliseAChercher	; Bit 7 de BaliseAChercher = 1, BaliseAChercher = 16 		

		; si BaliseAChercher>16 BaliseAChercher=16 
		MOVLW	D'17'
		SUBWF	BaliseAChercher, W
		BTFSS	STATUS, C
		RETURN			;	on revient
		
		MOVLW	D'16'
		MOVWF	BaliseAChercher	; BaliseAChercher = 16
				
		RETURN			;	on revient



;**********************************************************************
;                                                                     *
;    Attente d'une nouvelle interruption                   	      *
;                                                                     *
;                                                                     *
;**********************************************************************

AttenteNewInter 
		CLRF	NewInterrution	; On initialise NewInterrution, qui sera remis a 1 apres une interruption complete
AttenteBoucle	BTFSS	NewInterrution,0;	On attent que NewInterrution soit remis a 1 ...
		GOTO	AttenteBoucle	
		RETURN



;**********************************************************************
; Test de rception balise.
; Le signal  une priode de 4992microS
; Les balises mettent pendant 208microS * N ( N de 1  16 selon leur code )
;
; La fonction RecepBalise
; Elle lit 192 fois tous les 52micoS (total 9984microS soit 2 fois la priode )
;
; Paramtre CtolreBalise la tolrance de 1  10
;
; En sortie de la fonction 
; W = 0
; Balise = numero de la balise trouv de 1  16, ou 0
; 
; et
; DureeTmp duree du dernier niveau 1
; DureeTotal duree moyene du niveau 1
; DureeMax duree du plus grand
; Boucle = 0 
;
;**********************************************************************

RecepBalise
	CLRF	DureeTmp
	CLRF	DureeTotal
	CLRF	DureeMax
	MOVLW	D'192'
	MOVWF	Boucle

LRBBoucle
	INCF	DureeTmp,F	; DureeTmp+1

	BTFSC	PORTB,3		; si PortB(3)=0 (pas de detection)
	CLRF	DureeTmp	; alors DureeTmp=0

	BTFSS	PORTB,3		; si PortB(3)=1 (detection)
	INCF	DureeTotal,F	; DureeTotal+1

	MOVF	DureeTmp,W	; DureeMax=MAX(dureeMax,DureeTmp)
	SUBWF	DureeMax,W
	BTFSS	STATUS,C
	SUBWF	DureeMax,F

	MOVLW	D'10'		; Pause de 40+1 microS
LRBPause
	ADDLW	0xFF
	BTFSS	STATUS,Z
	GOTO	LRBPause

	DECFSZ	Boucle,F	; on fait ca 192 fois
	GOTO	LRBBoucle

; On calcule Balise=DureeMax/4
	BCF	STATUS,C
	RRF	DureeMax,W	; W=DureeMax/2
	MOVWF	Balise		; Balise=W
	BCF	STATUS,C
	RRF	Balise,F	; Balise=Balise/2 donc Balise=DureeMax/4

; Filtre si Balise > 16 Balise = 0
	MOVF	Balise,W
	SUBLW	D'16'		; W=16-W
	BTFSS	STATUS,C	; si W > 16
	CLRF	Balise		; Balise=0

; Calcule de W=Abs(DureeTotal/2 - DureeMax)
	BCF	STATUS,C	; DureeTotal/2
	RRF	DureeTotal,F

	MOVF	DureeMax,W	; W=DureeMax
	SUBWF	DureeTotal,W	; W=DureeTotal/2-DureeMax
	BTFSS	STATUS,C	; Si W < 0
	SUBLW	0		; alors W=-W

	SUBLW	CtolreBalise	; W=CtolreBalise-W
	BTFSS	STATUS,C	; si W > CtolreBalise
	CLRF	Balise		; alors Balise=0

Fin	RETLW	0

;**********************************************************************
;                                                                     *
;    Lecture dans l'EEPROM				       	      *
;                                                                     *
;                                                                     *
;**********************************************************************

; Adresse dans PointerEEProm
;  Retour dans W

LireEEProm
		BCF	STATUS, RP0	; Bank 0
		MOVF	PointerEEProm, W;
		MOVWF	EEADR		; Adresse a lire (PointerEEProm)
		BSF	STATUS, RP0	; Bank 1
		BSF	EECON1, RD	; Lecture dans l'EEProm
		BCF 	STATUS, RP0	; Bank 0
		MOVF	EEDATA, W	; W = EEDATA
	RETURN


;**********************************************************************
;                                                                     *
;    Initialisation des ports d'E/S                           	      *
;                                                                     *
;                                                                     *
;**********************************************************************


InitIO
	CLRF 	PORTA		; Initialise le port A
	CLRF	PORTB		; Initialise le port B
	BSF	STATUS, RP0	; Bank 1 selectonnee
	MOVLW	B'11111001'	; Port RB1 RB2 en sortie,RB7-RB3, RB0 en entre
	MOVWF	TRISB		;	/

	MOVLW	B'00011000'	; Port RA2-RA0 en sortie, RA4,RA3 en entre
	MOVWF	TRISA		;	/

	BCF 	STATUS,	RP0	; Bank 0 selectonnee
	RETURN


;**********************************************************************
;                                                                     *
;    Initialisation de l'interruption TimeR                           *
;                                                                     *
;                                                                     *
;**********************************************************************


InitRtcc

;*****  On regle le prescaler
	CLRWDT			; Clear WDT and prescaler
	BSF	STATUS, RP0	; Bank 1 selectonnee
	MOVLW	B'10000010'	; Timer interne, prescaler sur Timer, Prescaler a 8.
	MOVWF	OPTION_REG	;	/
	BCF	STATUS, RP0	; Bank 0 selectonnee

;*****  On regle l'interruption

	MOVLW	0xFA		; Initialisation de la valeur du TimeR
	MOVWF	TMR0		;	/

	MOVLW   B'10100000'     ; enable interrupts
	MOVWF   INTCON          ;       /
	RETURN

;**********************************************************************
;                                                                     *
;    Fin				                              *
;                                                                     *
;                                                                     *
;**********************************************************************


	END                     ; directive 'end of program'


Error[107]   C:\PROGRA~1\MPLAB\JOYEUX03.ASM 233 : Illegal digit
Error[108]   C:\PROGRA~1\MPLAB\JOYEUX03.ASM 233 : Illegal character (0)
Warning[207] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 234 : Found label after column 1. (D)
Error[108]   C:\PROGRA~1\MPLAB\JOYEUX03.ASM 234 : Illegal character (')
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 268 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 374 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 382 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 494 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 508 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 554 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 593 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 866 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1009 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1036 : Using default destination of 1 (file).
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1165 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1184 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1187 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1207 : Register in operand not in bank 0.  Ensure that bank bits are correct.

MPLAB is unable to find output file "JOYEUX03.hex".

Build failed.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 269 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 375 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 383 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 495 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 509 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 555 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 594 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 867 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1010 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1037 : Using default destination of 1 (file).
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1166 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1185 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1188 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1208 : Register in operand not in bank 0.  Ensure that bank bits are correct.

Build completed successfully.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 287 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 393 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 401 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 513 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 527 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 573 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 612 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 885 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1028 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1055 : Using default destination of 1 (file).
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1184 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1203 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1206 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX03.ASM 1226 : Register in operand not in bank 0.  Ensure that bank bits are correct.

Build completed successfully.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 294 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 400 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 408 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 520 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 534 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 580 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 619 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 892 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 1035 : Using default destination of 1 (file).
Message[305] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 1062 : Using default destination of 1 (file).
Message[302] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 1191 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 1210 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 1213 : Register in operand not in bank 0.  Ensure that bank bits are correct.
Message[302] C:\PROGRA~1\MPLAB\JOYEUX04.ASM 1233 : Register in operand not in bank 0.  Ensure that bank bits are correct.

Build completed successfully.
